#include <amxmodx>
#include <fun>
#include <engine>
#include <ColorChat>

#define MAX_USES 2

new Float:g_szPlayerOrigins[ 33 ][ 3 ];
new g_szPlayerUses[ 33 ];
new bool:g_szPlayerSaved[ 33 ];

public plugin_init( ) {
	
	register_plugin( "Respawn Position", "1.0.1", "Maka");
	
	register_clcmd( "say /save", "OnSave" );
	register_clcmd( "say /respawn", "OnRespawn" );
	
	register_event( "HLTV", "LogEvent_RoundStart", "a", "1=0", "2=0" );
}

public LogEvent_RoundStart( ) {
	
	for(new i = 1; i <= 32; i++) {
		
		g_szPlayerUses[ i ] = 0;
		g_szPlayerSaved[ i ] = false;
		
		g_szPlayerOrigins[ i ][ 0 ] = 0.0;
		g_szPlayerOrigins[ i ][ 1 ] = 0.0;
		g_szPlayerOrigins[ i ][ 2 ] = 0.0;
	}
}

public OnSave( id ) {
	
	if( !is_user_alive( id ) ) {
		ColorChat( id, GREEN, "[Respawn] ^1You must be alive to save your position.");
		return PLUGIN_HANDLED;
	}
	
	if( g_szPlayerUses[ id ] >= MAX_USES ) {
		ColorChat( id, GREEN, "[Respawn] ^1You have reached the maximum uses [^3%d^1] this round.", MAX_USES );
		return PLUGIN_HANDLED;
	}
	
	entity_get_vector( id, EV_VEC_origin, g_szPlayerOrigins[ id ] );
	g_szPlayerSaved[ id ] = true;
	
	ColorChat( id, GREEN, "[Respawn] ^1Position saved successfully! Uses remaining: ^3%d", MAX_USES - g_szPlayerUses[ id ] );
	return PLUGIN_HANDLED;
}

public OnRespawn( id ) {
	
	if( !is_user_alive( id ) ) {
		ColorChat( id, GREEN, "[Respawn] ^1You must be alive to use this command." );
		return PLUGIN_HANDLED;
	}
	
	if( !g_szPlayerSaved[ id ] || ( g_szPlayerOrigins[ id ][ 0 ] == 0.0 && g_szPlayerOrigins[ id ][ 1 ] == 0.0 && g_szPlayerOrigins[ id ][ 2 ] == 0.0 ) ) {
		ColorChat( id, GREEN, "[Respawn] ^1No position saved yet. Use ^3/save ^1first !")
		return PLUGIN_HANDLED;
	}
	
	if( g_szPlayerUses[id] >= MAX_USES ) {
		ColorChat( id, GREEN, "[Respawn] ^1You have reached the maximum uses [^3%d^1] this round.", MAX_USES );
		return PLUGIN_HANDLED;
	}
	
	CheckOrigin( id, g_szPlayerOrigins[ id ] );
	g_szPlayerUses[ id ] ++;
	
	g_szPlayerSaved[ id ] = false  ;
	g_szPlayerOrigins[ id ][ 0 ] = 0.0 ;
	g_szPlayerOrigins[ id ][ 1 ] = 0.0;
	g_szPlayerOrigins[ id ][ 2 ] = 0.0;  
	
	ColorChat( id, GREEN, "[Respawn] ^1Respawned at saved position! Uses remaining: ^3%d", MAX_USES - g_szPlayerUses[ id ] );
	return PLUGIN_HANDLED;
}

public client_putinserver( id ) {
	
	g_szPlayerOrigins[ id ][0] = 0.0;
	g_szPlayerOrigins[ id ][1] = 0.0;
	g_szPlayerOrigins[ id ][ 2 ] = 0.0;
	g_szPlayerUses[ id ] = 0;
	g_szPlayerSaved[ id ] = false;
}


stock CheckOrigin( id, Float:iOrigin[ 3 ] ) {
	
	new Float:iTeleport[ 3 ];
	
	iTeleport[ 0 ] = iOrigin[ 0 ] + 30.0;
	iTeleport[ 1 ] = iOrigin[ 1 ];
	iTeleport[ 2 ] = iOrigin[ 2 ];
	
	entity_set_vector( id, EV_VEC_origin, iTeleport );
}
